﻿using UnityEngine;

public class VertexColorRandomizer : MonoBehaviour {
    private void Awake()
    {
        // Create a random color
        Color32 newColor =
            new Color32(
                (byte)Random.Range(0, 256),
                (byte)Random.Range(0, 256),
                (byte)Random.Range(0, 256),
                255);

        // Get the mesh filter
        Mesh mesh = GetComponent<MeshFilter>().mesh;

        // Create an array of colors matching the same length as the mesh's color array
        Color32[] newColors = new Color32[mesh.vertices.Length];
        for (int vertexIndex = 0; vertexIndex < newColors.Length; vertexIndex++)
        {
            newColors[vertexIndex] = newColor;
        }

        // Apply the color
        mesh.colors32 = newColors;
    }
}
